package com.xuqm.server.appmanager.controller.sys.v1;

import cn.org.bjca.trust.java.imserver.common.TimeHelper;
import com.xuqm.server.appmanager.entitys.sys.v1.ApplicationEntity;
import com.xuqm.server.appmanager.entitys.sys.v1.TenantEntity;
import com.xuqm.server.appmanager.entitys.sys.v1.TenantUserEntity;
import com.xuqm.server.appmanager.http.HttpResult;
import com.xuqm.server.appmanager.repository.sys.v1.ApplicationRepository;
import com.xuqm.server.appmanager.repository.sys.v1.TenantRepository;
import com.xuqm.server.appmanager.repository.sys.v1.TenantUserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Random;

@RestController
@RequestMapping("tenant/v1")
public class TenantV1Controller {

    @Autowired
    private TenantRepository tenantRepository;
    @Autowired
    private TenantUserRepository tenantUserRepository;
    @Autowired
    private ApplicationRepository applicationRepository;

    @PostMapping("/tenant/create")
    public HttpResult<String> tenantCreate(@RequestBody TenantUserEntity tenant) throws Exception {
        if (null == tenant.getUserPhone() ||
                null == tenant.getUserEmail() ||
                null == tenant.getUserPwd()) {
            return new HttpResult<>(201, "参数错误", null);
        } else {
            TenantUserEntity u = tenantUserRepository.findFirstByUserEmailOrUserPhone(tenant.getUserEmail(), tenant.getUserPhone());
            if (null != u) return new HttpResult<>(201, "邮箱或手机号重复", null);
            u = new TenantUserEntity();
            u.setUserEmail(tenant.getUserEmail());
            u.setUserPhone(tenant.getUserPhone());
            u.setUserPwd(tenant.getUserPwd());
            u.setUserId(TimeHelper.getTimeString("yyyyMMddHHmm") + (new Random().nextInt(899999999) + 100000000));
            u.setTenantNo(TimeHelper.getTimeString("yyyyMMddHHmm") + (new Random().nextInt(899999999) + 100000000));
            tenantUserRepository.save(u);
            TenantEntity t = new TenantEntity();
            t.setUserId(u.getUserId());
            t.setTenantNo(u.getTenantNo());
            tenantRepository.save(t);

            return new HttpResult<>(200, "创建成功", "创建成功");
        }

    }

    @PostMapping("/app/create")
    public HttpResult<String> appCreate(@RequestBody ApplicationEntity application) throws Exception {
        if (null == application.getAppName() ||
                null == application.getTenantNo()) {
            return new HttpResult<>(201, "参数错误", null);
        } else {
            ApplicationEntity app = applicationRepository.findFirstByAppNameAndTenantNo(application.getAppName(), application.getTenantNo());
            if (null != app) return new HttpResult<>(201, "已创建相关类型的同名应用", null);
            app = new ApplicationEntity();
            app.setTenantNo(application.getTenantNo());
            app.setAppName(application.getAppName());
            app.setAppId(TimeHelper.getTimeString("yyyyMMddHHmm") + (new Random().nextInt(899999999) + 100000000));
            applicationRepository.save(app);

            return new HttpResult<>(200, "创建成功", "创建成功");
        }

    }

}
